package com.consultingwerk.plugins.smartunitlaunchconfig;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.ui.plugin.AbstractUIPlugin;

import com.consultingwerk.plugins.common.utilities.ConsoleHelper;
import com.consultingwerk.plugins.common.utilities.FileHelper;
import com.consultingwerk.plugins.common.utilities.PreferencesHelper;

/**
 * Controls the lifecycle of the plugin 
 */
public class SmartUnitActivator 
    extends AbstractUIPlugin 
{
    private final IPreferenceStore store;
    
    /**
     * Constructor for the SmartUnitActovator class
     */
    public SmartUnitActivator () 
    {
        super();
        
        IPreferenceStore newStore = null;
        
        try 
        {
            newStore = PreferencesHelper.getStore (SmartUnitAttributes.Store, 
                                                   FileHelper.findPluginFile (SmartUnitAttributes.PluginID, 
                                                                              "preferences.txt"));
        } 
        catch (Exception e) 
        {
            ConsoleHelper.printException (e);
        }
        finally
        {
            this.store = newStore;
        }
    }

    /**
     * Returns the activators PreferenceStore
     */
    @Override
    public IPreferenceStore getPreferenceStore () 
    {
        return this.store;
    }
}
