package com.consultingwerk.plugins.smartunitlaunchconfig.shortcuts;

import org.eclipse.debug.ui.ILaunchShortcut;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IEditorPart;

import com.consultingwerk.plugins.common.utilities.FileHelper;
import com.consultingwerk.plugins.smartunitlaunchconfig.SmartUnitAttributes;

/**
 * Shortcut to launch a SmartUnit scenario test
 */
public class ScenarioShortcut 
    extends SmartUnitShortcut
    implements ILaunchShortcut 
{
    /**
     * Launches the shortcut for a selection
     * @param selection The selection to launch for
     * @param mode The mode to launch in (run, debug, ...)
     */
    @Override
    public void launch (ISelection selection, 
                        String mode) 
    {
        this.launch (FileHelper.getFilename(selection), 
                     null,
                     SmartUnitAttributes.ScenarioTestTypeID, 
                     mode);
    }

    /**
     * Launches the shortcut for an editor
     * @param editor The EditorPart to launch for
     * @param mode The mode to launch in (run, debug, ...)
     */
    @Override
    public void launch (IEditorPart editor, 
                        String mode) 
    {
        this.launch (FileHelper.getFilename(editor), 
                     null,
                     SmartUnitAttributes.ScenarioTestTypeID, 
                     mode);
    }
}
