package com.consultingwerk.plugins.smartunitlaunchconfig.ui.views;

import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import com.consultingwerk.plugins.common.utilities.ConsoleHelper;
import com.consultingwerk.plugins.smartunitlaunchconfig.SmartUnitAttributes;

/**
 * Launches the SmartUnitView, reuses existing view if possible
 */
public class SmartUnitViewLauncher 
{
    /**
     * Launches the SmartUnitView for the given file
     * @param filename
     */
    public static void openFile (String filename)
    {
        try 
        {
            IEditorPart editor;
            for(IWorkbenchPage page: PlatformUI.getWorkbench().getActiveWorkbenchWindow().getPages())
            {
                for(IEditorReference ref: page.findEditors(new SmartUnitViewInput (filename), 
                                                           SmartUnitAttributes.SmartUnitViewID, 
                                                           IWorkbenchPage.MATCH_ID))
                    {
                        editor = ref.getEditor(true);
                        ((SmartUnitView) editor).openFile(filename);
                        editor.setFocus();
                        return;
                    }
            }           
            editor = PlatformUI.getWorkbench ()
                               .getActiveWorkbenchWindow ()
                               .getActivePage ()
                               .openEditor (new SmartUnitViewInput (filename), 
                                            SmartUnitAttributes.SmartUnitViewID, 
                                            true, 
                                            IWorkbenchPage.MATCH_ID);
            ((SmartUnitView) editor).openFile(filename);
            editor.setFocus();
        } 
        catch (PartInitException e) 
        {
            ConsoleHelper.printException (e);
        }
    }
}
